/*
 *   $Id: routine.h,v 1.3 2025/03/09 19:50:47 snw Exp $
 *    Routine buffer constants and prototypes
 *
 *  
 *   Author: Serena Willis <snw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2023, 2025 Coherent Logic Development LLC
 *
 *
 *   This file is part of FreeM.
 *
 *   FreeM is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   FreeM is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero Public License for more details.
 *
 *   You should have received a copy of the GNU Affero Public License
 *   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
 *
 *   $Log: routine.h,v $
 *   Revision 1.3  2025/03/09 19:50:47  snw
 *   Second phase of REUSE compliance and header reformat
 *
 *
 * SPDX-FileCopyrightText:  (C) 2025 Coherent Logic Development LLC
 * SPDX-License-Identifier: AGPL-3.0-or-later
 **/

#if !defined(_FREEM_ROUTINE_H)
# define _FREEM_ROUTINE_H

typedef struct rtn_arg {
    char *arg_name;
    char *arg_type;
    short reference;
} rtn_arg;
    

typedef struct m_entry {
    char *tag;
    char *return_type;

    rtn_arg args[20];
    int argct;
    
    struct m_entry *next;
} m_entry;

extern short rtn_get_offset(char *buf);
extern char *rtn_resolve(char *rou, char *tag, char *buf);
extern short rtn_get_superclass(char *rou, char *buf);
extern short rtn_get_path(char *rou, char *buf);
extern short rtn_has_tag(char *rou, char *tag);
extern void rtn_free_entries(m_entry *head);
extern m_entry *rtn_get_entries(char *rou);
extern void zload(char *rou);
extern void zsave(char *rou);
extern void getraddress (char *a, short lvl);
#endif
