/*
 *   $Id: tp_check.h,v 1.3 2025/03/09 19:50:47 snw Exp $
 *    TP checkpointing declarations
 *
 *  
 *   Author: Serena Willis <snw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2022, 2025 Coherent Logic Development LLC
 *
 *
 *   This file is part of FreeM.
 *
 *   FreeM is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   FreeM is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero Public License for more details.
 *
 *   You should have received a copy of the GNU Affero Public License
 *   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
 *
 *   $Log: tp_check.h,v $
 *   Revision 1.3  2025/03/09 19:50:47  snw
 *   Second phase of REUSE compliance and header reformat
 *
 *
 * SPDX-FileCopyrightText:  (C) 2025 Coherent Logic Development LLC
 * SPDX-License-Identifier: AGPL-3.0-or-later
 **/

#define CP_UNUSED 0
#define CP_REMOVE 1
#define CP_RESTORE 2

typedef struct cptab {

    char mode; /* CP_UNUSED, CP_REMOVE, or CP_RESTORE */

    char *global; /* global name */
    char *file; /* fully-qualified file path */

    char *cp_file; /* fully-qualified checkpoint file path */

    struct cptab *next;

} cptab;

extern cptab *cptab_head[];

extern cptab *cptab_insert(int tlevel, char *global);
extern cptab *cptab_retrieve(int tlevel, char *global);
extern void cptab_delete(int tlevel, char *global);
extern short cptab_precommit(int tlevel);
extern void cptab_postcommit(int tlevel);
extern void cptab_dump(int tlevel);
short cptab_rollback(int tlevel);
    
